#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Makefile for the test program  
# C/C++ Compiler Used: Microsoft Visual C/C++ 4.2 
# Produced By: Doug Gaer
# File Creation Date: 03/21/1997 
# Date Last Modified: 10/15/1998 
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# Complier Flags 
#	Zi -- Enable debugging
#       W3 -- Turn on warnings 
#       GX -- Enable C++ exception handling
#       GR -- Enable C++ Run-Time Type Information
# --------------------------------------------------------------- 
# Define a name for the executable
PROJECT = testprog

# Setup additional paths for includes and source code
BASE_PATH = ../base/
CACHE_PATH = ../../cache/base/
EHANDLER_PATH = ../../ehandler/base/
DTYPES_PATH = ../../dtypes/base/
VBDFILE_PATH = ../../vbdfile/base/
REFCOUNT_PATH = ../../refcount/base/
PLACENEW_PATH = ../../placenew/base/
USTRING_PATH = ../../ustring/base/
STRUTIL_PATH = ../../strutil/base/
CRC32_PATH = ../../crc32/base/

ADD_INC_PATHS = /I../base /I../../ehandler/base /I../../dtypes/base \
/I../../vbdfile/base /I../../pod/base /I../../refcount/base \
/I../../cache/base /I../../placenew/base /I../../ustring/base \
/I../../strutil/base /I../../crc32/base

# Alloaction method used to reclaim deleted blocks
DEF_VB_ALLOC = /D__RECLAIM_BEST_FIT__ 
#DEF_VB_ALLOC = /D__RECLAIM_FIRST_FIT__ 

# Use this DEFMACS macro to compile without using template classes
DEFMACS = /D__NOT_USING_TEMPLATE_CLASS__ /D__BTREE_MNODE__ /D__CONSOLE__ \
/D__USE_VBDREFCOUNT__ /D__DOS__ $(DEF_VB_ALLOC) # /DCPP_EXCEPTIONS

# Enable to use the template classes
# DEFMACS = /D__CONSOLE__ /D__DOS__ $(DEF_VB_ALLOC) # /DCPP_EXCEPTIONS

# Define macros for compiler and linker
CC = cl
CPP = cl
LINKER = link

# Define compiler and linker flags macros
CFLAGS= /Zi /GX $(ADD_INC_PATHS) $(DEFMACS)
COMPILE_ONLY = /c
LFLAGS =  

# Build dependency rules
# ===============================================================
VBDSTATS_DEP = $(DTYPES_PATH)dtypes.hpp $(EHANDLER_PATH)ehandler.hpp \
	$(DTYPES_PATH)int32.hpp $(VBDFILE_PATH)vbdfile.hpp \
	$(REFCOUNT_PATH)refcount.hpp $(DTYPES_PATH)uint32.hpp \
	$(CRC32_PATH)crc32.hpp

CRC32_DEP = $(CRC32_PATH)crc32.hpp $(CRC32_PATH)crc32tab.hpp

UINT32_DEP = $(DTYPES_PATH)dtypes.hpp $(EHANDLER_PATH)ehandler.hpp \
	$(DTYPES_PATH)uint32.hpp

BUCKET_DEP = $(CACHE_PATH)bucket.hpp $(CACHE_PATH)cacheb.hpp \
	$(CACHE_PATH)cactype.hpp $(EHANDLER_PATH)ehandler.hpp \
	$(VBDFILE_PATH)vbdfile.hpp $(BASE_PATH)mnode.hpp \
	$(REFCOUNT_PATH)refcount.hpp $(BASE_PATH)mnode.hpp \
	$(DTYPES_PATH)uint32.hpp

CACHE_DEP = $(CACHE_PATH)bucketb.hpp $(CACHE_PATH)cacheb.hpp \
	$(CACHE_PATH)cactype.hpp $(EHANDLER_PATH)ehandler.hpp \
	$(VBDFILE_PATH)vbdfile.hpp $(BASE_PATH)mnode.hpp \
	$(REFCOUNT_PATH)refcount.hpp $(BASE_PATH)mnode.hpp \
	$(DTYPES_PATH)uint32.hpp	

CACHEB_DEP = $(CACHE_PATH)bucketb.hpp $(CACHE_PATH)cacheb.hpp \
	$(EHANDLER_PATH)ehandler.hpp $(VBDFILE_PATH)vbdfile.hpp \
	$(REFCOUNT_PATH)refcount.hpp $(DTYPES_PATH)int32.hpp \
	$(DTYPES_PATH)dtypes.hpp $(DTYPES_PATH)uint32.hpp

CHPTRB_DEP = $(CACHE_PATH)bucket.hpp $(CACHE_PATH)bucketb.hpp \
	$(CACHE_PATH)cache.hpp $(CACHE_PATH)cacheb.hpp \
	$(CACHE_PATH)chptrb.hpp $(CACHE_PATH)cactype.hpp\
	$(EHANDLER_PATH)ehandler.hpp $(VBDFILE_PATH)vbdfile.hpp \
	$(REFCOUNT_PATH)refcount.hpp $(DTYPES_PATH)int32.hpp \
	$(DTYPES_PATH)dtypes.hpp $(DTYPES_PATH)uint32.hpp

BTREE_DEP = $(CACHE_PATH)bucket.hpp $(CACHE_PATH)bucketb.hpp \
	$(CACHE_PATH)cache.hpp $(CACHE_PATH)cacheb.hpp \
	$(CACHE_PATH)chptrb.hpp $(CACHE_PATH)cactype.hpp\
	$(CACHE_PATH)cacheptr.hpp $(BASE_PATH)btree.hpp \
	$(EHANDLER_PATH)ehandler.hpp $(VBDFILE_PATH)vbdfile.hpp \
	$(REFCOUNT_PATH)refcount.hpp $(PLACENEW_PATH)placenew.hpp \
	$(DTYPES_PATH)int32.hpp  $(DTYPES_PATH)dtypes.hpp \
	$(BASE_PATH)mnode.hpp $(BASE_PATH)entrykey.hpp \
	$(DTYPES_PATH)uint32.hpp

BTREEPRT_DEP = $(CACHE_PATH)bucket.hpp $(CACHE_PATH)bucketb.hpp \
	$(CACHE_PATH)cache.hpp $(CACHE_PATH)cacheb.hpp \
	$(CACHE_PATH)chptrb.hpp $(CACHE_PATH)cactype.hpp\
	$(CACHE_PATH)cacheptr.hpp $(BASE_PATH)btree.hpp \
	$(EHANDLER_PATH)ehandler.hpp $(VBDFILE_PATH)vbdfile.hpp \
	$(REFCOUNT_PATH)refcount.hpp $(PLACENEW_PATH)placenew.hpp \
	$(DTYPES_PATH)int32.hpp  $(DTYPES_PATH)dtypes.hpp \
	$(BASE_PATH)mnode.hpp $(BASE_PATH)btreeprt.hpp \
	$(BASE_PATH)entrykey.hpp $(DTYPES_PATH)uint32.hpp

BTWALK_DEP = $(CACHE_PATH)bucket.hpp $(CACHE_PATH)bucketb.hpp \
	$(CACHE_PATH)cache.hpp $(CACHE_PATH)cacheb.hpp \
	$(CACHE_PATH)chptrb.hpp $(CACHE_PATH)cactype.hpp\
	$(CACHE_PATH)cacheptr.hpp $(BASE_PATH)btree.hpp \
	$(EHANDLER_PATH)ehandler.hpp $(VBDFILE_PATH)vbdfile.hpp \
	$(REFCOUNT_PATH)refcount.hpp $(PLACENEW_PATH)placenew.hpp \
	$(DTYPES_PATH)int32.hpp  $(DTYPES_PATH)dtypes.hpp \
	$(BASE_PATH)mnode.hpp $(BASE_PATH)btreeprt.hpp \
	$(BASE_PATH)entrykey.hpp $(USTRING_PATH)ustring.hpp \
	$(STRUTIL_PATH)strutil.hpp $(DTYPES_PATH)uint32.hpp

CACSTATS_DEP = $(CACHE_PATH)bucketb.hpp $(CACHE_PATH)cacheb.hpp \
	$(EHANDLER_PATH)ehandler.hpp $(VBDFILE_PATH)vbdfile.hpp \
	$(REFCOUNT_PATH)refcount.hpp $(DTYPES_PATH)int32.hpp \
	$(DTYPES_PATH)dtypes.hpp $(CACHE_PATH)cacstats.hpp \
	$(DTYPES_PATH)uint32.hpp

ENTRYKEY_DEP = $(BASE_PATH)entrykey.hpp $(DTYPES_PATH)dtypes.hpp \
	$(EHANDLER_PATH)ehandler.hpp $(DTYPES_PATH)int32.hpp

MNODE_DEP = $(BASE_PATH)mnode.hpp $(DTYPES_PATH)dtypes.hpp \
	$(EHANDLER_PATH)ehandler.hpp $(DTYPES_PATH)int32.hpp \
	$(BASE_PATH)entrykey.hpp

EHANDLER_DEP = $(EHANDLER_PATH)ehandler.hpp

INT32_DEP = $(DTYPES_PATH)dtypes.hpp $(EHANDLER_PATH)ehandler.hpp \
	$(DTYPES_PATH)int32.hpp

VBDFILE_DEP = $(DTYPES_PATH)dtypes.hpp $(EHANDLER_PATH)ehandler.hpp \
	$(DTYPES_PATH)int32.hpp $(VBDFILE_PATH)vbdfile.hpp \
	$(REFCOUNT_PATH)refcount.hpp $(DTYPES_PATH)uint32.hpp \
	$(CRC32_PATH)crc32.hpp

VBDREF_DEP = $(VBDFILE_PATH)vbdfile.hpp \
	$(VBDFILE_PATH)vbdref.hpp $(REFCOUNT_PATH)refcount.hpp

USTRING_DEP = $(USTRING_PATH)ustring.hpp

STRUTIL_DEP = $(STRUTIL_PATH)strutil.hpp

TESTPROG_DEP = $(CACHE_PATH)bucket.hpp $(CACHE_PATH)bucketb.hpp \
	$(CACHE_PATH)cache.hpp $(CACHE_PATH)cacheb.hpp \
	$(CACHE_PATH)chptrb.hpp $(CACHE_PATH)cacheptr.hpp \
	$(CACHE_PATH)cactype.hpp $(BASE_PATH)btree.hpp \
	$(EHANDLER_PATH)ehandler.hpp $(DTYPES_PATH)int32.hpp \
        $(VBDFILE_PATH)vbdfile.hpp $(REFCOUNT_PATH)refcount.hpp \
	$(PLACENEW_PATH)placenew.hpp $(BASE_PATH)mnode.hpp \
	$(BASE_PATH)btreeprt.hpp $(BASE_PATH)entrykey.hpp \
	$(BASE_PATH)btwalk.hpp $(CACHE_PATH)cacstats.hpp \
	$(USTRING_PATH)ustring.hpp $(STRUTIL_PATH)strutil.hpp \
	$(DTYPES_PATH)uint32.hpp $(VBDFILE_PATH)vbdstats.hpp
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT).exe

vbdstats.obj:    $(VBDFILE_PATH)vbdstats.cpp $(VBDFILE_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(VBDFILE_PATH)vbdstats.cpp

uint32.obj:	$(DTYPES_PATH)uint32.cpp $(UINT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(DTYPES_PATH)uint32.cpp

crc32.obj:	$(CRC32_PATH)crc32.cpp $(CRC32_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(CRC32_PATH)crc32.cpp

bucket.obj:	$(CACHE_PATH)bucket.cpp $(BUCKET_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(CACHE_PATH)bucket.cpp

cache.obj:	$(CACHE_PATH)cache.cpp $(CACHE_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(CACHE_PATH)cache.cpp

cacheb.obj:	$(CACHE_PATH)cacheb.cpp $(CACHEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(CACHE_PATH)cacheb.cpp

chptrb.obj:	$(CACHE_PATH)chptrb.cpp $(CHPTRB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(CACHE_PATH)chptrb.cpp

cacstats.obj:	$(CACHE_PATH)cacstats.cpp $(CACSTATS_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(CACHE_PATH)cacstats.cpp

mnode.obj:	$(BASE_PATH)mnode.cpp $(MNODE_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(BASE_PATH)mnode.cpp

entrykey.obj:	$(BASE_PATH)entrykey.cpp $(ENTRYKEY_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(BASE_PATH)entrykey.cpp

btree.obj:	$(BASE_PATH)btree.cpp $(BTREE_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(BASE_PATH)btree.cpp

btreeprt.obj:	$(BASE_PATH)btreeprt.cpp $(BTREEPRT_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(BASE_PATH)btreeprt.cpp

btwalk.obj:	$(BASE_PATH)btwalk.cpp $(BTWALK_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(BASE_PATH)btwalk.cpp

ehandler.obj:	$(EHANDLER_PATH)ehandler.cpp $(EHANDLER_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(EHANDLER_PATH)ehandler.cpp

int32.obj:	$(DTYPES_PATH)int32.cpp $(INT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(DTYPES_PATH)int32.cpp

vbdfile.obj:    $(VBDFILE_PATH)vbdfile.cpp $(VBDFILE_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(VBDFILE_PATH)vbdfile.cpp

vbdref.obj:	$(VBDFILE_PATH)vbdref.cpp $(VBDREF_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(VBDFILE_PATH)vbdref.cpp

ustring.obj:	$(USTRING_PATH)ustring.cpp $(USTRING_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(USTRING_PATH)ustring.cpp 

strutil.obj:	$(STRUTIL_PATH)strutil.cpp $(STRUTIL_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(STRUTIL_PATH)strutil.cpp 

testprog.obj:	testprog.cpp $(TESTPROG_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) testprog.cpp

# Make the executable
OBJS = cacheb.obj chptrb.obj btree.obj ehandler.obj vbdfile.obj \
	testprog.obj mnode.obj int32.obj bucket.obj cache.obj \
	vbdref.obj entrykey.obj btreeprt.obj cacstats.obj \
	btwalk.obj strutil.obj ustring.obj crc32.obj uint32.obj \
	vbdstats.obj
 
$(PROJECT).exe:	$(OBJS)
	$(LINKER) $(LFLAGS) $(OBJS) /OUT:$@ 
# ===============================================================

# Remove OBJS, debug files, and executable after running nmake 
# ===============================================================
clean:
	@echo Removing all .SBR files from working directory...
	if exist *.sbr del *.sbr  

	@echo Removing all .VCW files from working directory...
	if exist *.vcw del *.vcw 

	@echo Removing all .PDB files from working directory...
	if exist *.pdb del *.pdb 

	@echo Removing all .WSP files from working directory...
	if exist *.wsp del *.wsp 

	@echo Removing all .BSC files from working directory...
	if exist *.bsc del *.bsc 

	@echo Removing all .SBT files from working directory...
	if exist *.sbt del *.sbt 

	@echo Removing all .ILK files from working directory...
	if exist *.ilk del *.ilk 

	@echo Removing all .IDB files from working directory...
	if exist *.idb del *.idb 

	@echo Removing all .MDP files from working directory...
	if exist *.mdp del *.mdp 

	@echo Removing all .PCH files from working directory...
	if exist *.pch del *.pch 

	@echo Removing all .NCB files from working directory...
	if exist *.ncb del *.ncb 

	@echo Removing all .OBJ files from working directory...
	if exist *.obj del *.obj 

	@echo Removing the EXECUTABLE file from working directory
	if exist $(PROJECT).exe del $(PROJECT).exe 

	@echo Removing any test files created during program execution
	if exist *.btx del *.btx
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################


