#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Makefile for the test program 
# C/C++ Compiler Used: GNU g++ 2.7.2.1
# Produced By: Doug Gaer
# File Creation Date: 04/09/1997 
# Date Last Modified: 01/17/1998 
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# Complier Flags 
#       v -- Echo compilation
#       g -- Enable debugging
#       Wall -- Turn on warnings 
#
# --------------------------------------------------------------- 
SHELL = /bin/sh

# Define a name for the executable
PROJECT = testprog

# Setup additional paths for includes and source code
BASE_PATH = ../base/
QUEUE_PATH = ../../queue/base/
SLLISTB_PATH = ../../sllist/base/
STACK_PATH = ../../stack/base/
USTRING_PATH = ../../ustring/base/

ADD_INC_PATHS = -I../base -I../../queue/base -I../../sllist/base \
-I../../stack/base -I../../ustring/base

# Setup define macros
DEFMACS = 

# Define macros for compiler and linker
CC = gcc
CPP = g++ 
LINKER = ld

# Define compiler and linker flags macros
CFLAGS= -v -Wall $(ADD_INC_PATHS) $(DEFMACS)
COMPILE_ONLY = -c
OUTPUT = -o
LFLAGS =  

# Build dependency rules
# ===============================================================
BNODEB_DEP = $(BASE_PATH)bnodeb.hpp $(QUEUE_PATH)queue.hpp \
	$(SLLISTB_PATH)sllist.hpp $(SLLISTB_PATH)sllistb.hpp \
	$(STACK_PATH)stack.hpp

BSTREEB_DEP = $(BASE_PATH)bnode.hpp $(BASE_PATH)bnodeb.hpp \
	$(BASE_PATH)bstreeb.hpp

RBTREEB_DEP = $(BASE_PATH)bnode.hpp $(BASE_PATH)bnodeb.hpp \
	$(BASE_PATH)bstreeb.hpp $(QUEUE_PATH)queue.hpp \
	$(BASE_PATH)rbnode.hpp $(BASE_PATH)rbtree.hpp \
	$(BASE_PATH)rbtreeb.hpp $(SLLISTB_PATH)sllist.hpp \
	$(SLLISTB_PATH)sllistb.hpp $(STACK_PATH)stack.hpp \
	$(BASE_PATH)twalk.hpp

SLLISTB_DEP = $(SLLISTB_PATH)sllistb.hpp

TESTPROG_DEP = $(BASE_PATH)bnode.hpp $(BASE_PATH)bnodeb.hpp \
	$(BASE_PATH)bstreeb.hpp $(QUEUE_PATH)queue.hpp \
	$(BASE_PATH)rbnode.hpp $(BASE_PATH)rbtree.hpp \
	$(BASE_PATH)rbtreeb.hpp $(SLLISTB_PATH)sllist.hpp \
	$(SLLISTB_PATH)sllistb.hpp $(STACK_PATH)stack.hpp \
	$(BASE_PATH)treeprt.hpp $(BASE_PATH)twalk.hpp \
	$(USTRING_PATH)ustring.hpp

TREEPRT_DEP = $(BASE_PATH)bnode.hpp $(BASE_PATH)bnodeb.hpp \
	$(QUEUE_PATH)queue.hpp $(BASE_PATH)rbnode.hpp \
	$(SLLISTB_PATH)sllist.hpp $(SLLISTB_PATH)sllistb.hpp \
	$(STACK_PATH)stack.hpp $(BASE_PATH)treeprt.hpp \
	$(BASE_PATH)twalk.hpp

TWALK_DEP = $(BASE_PATH)bnode.hpp $(BASE_PATH)bnodeb.hpp \
	$(QUEUE_PATH)queue.hpp $(BASE_PATH)rbnode.hpp \
	$(SLLISTB_PATH)sllist.hpp $(SLLISTB_PATH)sllistb.hpp \
	$(STACK_PATH)stack.hpp $(BASE_PATH)twalk.hpp

USTRING_DEP = $(USTRING_PATH)ustring.hpp
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT) 


bnodeb.o:	$(BASE_PATH)bnodeb.cpp $(BNODEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(BASE_PATH)bnodeb.cpp

bstreeb.o:	$(BASE_PATH)bstreeb.cpp $(BSTREEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(BASE_PATH)bstreeb.cpp

rbtreeb.o:	$(BASE_PATH)rbtreeb.cpp $(RBTREEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(BASE_PATH)rbtreeb.cpp

sllistb.o:	$(SLLISTB_PATH)sllistb.cpp $(SLLISTB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(SLLISTB_PATH)sllistb.cpp

testprog.o:	testprog.cpp $(TESTPROG_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) testprog.cpp

treeprt.o:	$(BASE_PATH)treeprt.cpp $(TREEPRT_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(BASE_PATH)treeprt.cpp

twalk.o:	$(BASE_PATH)twalk.cpp $(TWALK_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(BASE_PATH)twalk.cpp

ustring.o:	$(USTRING_PATH)ustring.cpp $(USTRING_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(USTRING_PATH)ustring.cpp

# Make the executable
OBJS = bnodeb.o bstreeb.o rbtreeb.o sllistb.o testprog.o \
	treeprt.o twalk.o ustring.o

$(PROJECT):	$(OBJS)
	$(CPP) $(CFLAGS) $(OBJS) $(OUTPUT) $(PROJECT) 
# ===============================================================

# Remove object files and the executable after running make 
# ===============================================================
clean:
	echo Removing all OBJECT files from working directory...
	rm -f *.o 

	echo Removing EXECUTABLE file from working directory...
	rm -f $(PROJECT)

# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################
