#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Make file for the WX windows program
# C/C++ Compiler Used: Microsoft Visual C/C++ 4.2
# Produced By: Doug Gaer
# File Creation Date: 12/16/1997 
# Date Last Modified: 11/02/1998 
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# Complier Flags 
#	Zi -- Enable debugging
#       W3 -- Turn on warnings 
#       GX -- Enable C++ exception handling
#       GR -- Enable C++ Run-Time Type Information
# 	Zp -- Byte align structures (leave no gaps between members)
# --------------------------------------------------------------- 
# Define this macro in the main makefile for this application
# Name for the executable
PROJECT = groceryw

# Define this macro in the main makefile for this application
# Installation directory for the application and config files
INSTALL_DIR = ..\bin

# Define the $(WXDIR) macro in the main makefile for this application
# Setup wxWindows for installation directory
!include ..\..\..\env\wx_msvc.env

# wxWindows complier/linker options 
!include $(WXDIR)\src\ntwxwin.mak

# Define the $(VBDDIR) macro in the main makefile for this application
# Setup path for VBD Base installation directory
# The $(VBDDIR) is defined in the include file.
!include ..\..\..\env\vbd_msvc.env

# Macro for path separator
PATHSEP=/

# Setup additional paths for includes and source code
APP_PATH = $(VBDDIR)$(PATHSEP)examples$(PATHSEP)grocery$(PATHSEP)wxwin
GROCERY_PATH = $(VBDDIR)$(PATHSEP)examples$(PATHSEP)grocery$(PATHSEP)base
QUEUE_PATH = $(VBDDIR)$(PATHSEP)classes$(PATHSEP)queue$(PATHSEP)base
STACK_PATH = $(VBDDIR)$(PATHSEP)classes$(PATHSEP)stack$(PATHSEP)base
RBTREE_PATH = $(VBDDIR)$(PATHSEP)classes$(PATHSEP)rbtree$(PATHSEP)base
BTREE_PATH = $(VBDDIR)$(PATHSEP)classes$(PATHSEP)btree$(PATHSEP)base
CACHE_PATH = $(VBDDIR)$(PATHSEP)classes$(PATHSEP)cache$(PATHSEP)base
EHANDLER_PATH = $(VBDDIR)$(PATHSEP)classes$(PATHSEP)ehandler$(PATHSEP)base
DTYPES_PATH = $(VBDDIR)$(PATHSEP)classes$(PATHSEP)dtypes$(PATHSEP)base
REFCOUNT_PATH = $(VBDDIR)$(PATHSEP)classes$(PATHSEP)refcount$(PATHSEP)base
USTRING_PATH = $(VBDDIR)$(PATHSEP)classes$(PATHSEP)ustring$(PATHSEP)base
VBDFILE_PATH = $(VBDDIR)$(PATHSEP)classes$(PATHSEP)vbdfile$(PATHSEP)base
SLLISTB_PATH = $(VBDDIR)$(PATHSEP)classes$(PATHSEP)sllist$(PATHSEP)base
STRUTIL_PATH = $(VBDDIR)$(PATHSEP)classes$(PATHSEP)strutil$(PATHSEP)base
CONFIG_PATH = $(VBDDIR)$(PATHSEP)classes$(PATHSEP)config$(PATHSEP)base
CHSLIST_PATH = $(VBDDIR)$(PATHSEP)classes$(PATHSEP)chslist$(PATHSEP)base
POD_PATH = $(VBDDIR)$(PATHSEP)classes$(PATHSEP)pod$(PATHSEP)base
PERSIST_PATH = $(VBDDIR)$(PATHSEP)classes$(PATHSEP)persist$(PATHSEP)base
TIMER_PATH = $(VBDDIR)$(PATHSEP)classes$(PATHSEP)timer$(PATHSEP)base
PLACENEW_PATH = $(VBDDIR)$(PATHSEP)classes$(PATHSEP)placenew$(PATHSEP)base
DLLISTB_PATH = $(VBDDIR)$(PATHSEP)classes$(PATHSEP)dllist$(PATHSEP)base
PSCRIPT_PATH = $(VBDDIR)$(PATHSEP)classes$(PATHSEP)pscript$(PATHSEP)base
CRC32_PATH = $(VBDDIR)$(PATHSEP)classes$(PATHSEP)crc32$(PATHSEP)base
ASPRINT_PATH = $(VBDDIR)$(PATHSEP)classes$(PATHSEP)asprint$(PATHSEP)base

ADD_INC_PATHS = /I$(EHANDLER_PATH) /I$(DTYPES_PATH) /I$(USTRING_PATH) \
/I$(VBDFILE_PATH) /I$(REFCOUNT_PATH) /I$(BTREE_PATH) /I$(SLLISTB_PATH) \
/I$(GROCERY_PATH) /I$(STRUTIL_PATH) /I$(CONFIG_PATH) /I$(CHSLIST_PATH) \
/I$(POD_PATH) /I$(PERSIST_PATH) /I$(TIMER_PATH) /I$(CACHE_PATH) \
/I$(PLACENEW_PATH) /I$(DLLISTB_PATH) /I$(QUEUE_PATH) /I$(STACK_PATH) \
/I$(RBTREE_PATH) /I$(DBCONFIG_PATH) /I$(APP_PATH) /I$(PSCRIPT_PATH) \
/I$(CRC32_PATH) /I$(ASPRINT_PATH)

# Alloaction method used to reclaim deleted blocks
#DEF_VB_ALLOC = /D__RECLAIM_BEST_FIT__ 
DEF_VB_ALLOC = /D__RECLAIM_FIRST_FIT__ 

# Use this DEFMACS macro to compile without using template classes
DEFMACS = /D__NOT_USING_TEMPLATE_CLASS__ /D__BTREE_MNODE__ /D__wxWINDOWS__ \
/D__USE_VBDREFCOUNT__ /D__DOS__ /D__USE_MSW_PRINTING__  /D__X86__ \
$(DEF_VB_ALLOC) # /DCPP_EXCEPTIONS

# Define macros for compiler and linker
AC     = cl   # ANSI c compiler
CPP    = cl   # C++ compiler
LINKER = link # Linker

# Resource compiler for MSVC
RC = rc

# Compiler and linker flags 
COMPILE_FLAGS= $(CPPFLAGS2) $(ADD_INC_PATHS) $(DEFMACS) 
COMPILE_ONLY = /c
LINK_FLAGS = $(LINKFLAGS)
LINK_LIBS = $(LIBS)

# Build dependency rules
# ===============================================================
VBDSTATS_DEP = $(EHANDLER_PATH)$(PATHSEP)ehandler.hpp \
	$(VBDFILE_PATH)$(PATHSEP)vbdfile.hpp \
	$(REFCOUNT_PATH)$(PATHSEP)refcount.hpp \
	$(DTYPES_PATH)$(PATHSEP)dtypes.hpp \
	$(DTYPES_PATH)$(PATHSEP)int32.hpp \
	$(DTYPES_PATH)$(PATHSEP)uint32.hpp 

CRC32_DEP = $(CRC32_PATH)$(PATHSEP)crc32.hpp \
	$(CRC32_PATH)$(PATHSEP)crc32tab.hpp 

UINT32_DEP =  $(EHANDLER_PATH)$(PATHSEP)ehandler.hpp \
	$(DTYPES_PATH)$(PATHSEP)dtypes.hpp \
	$(DTYPES_PATH)$(PATHSEP)uint32.hpp

BUCKET_DEP = $(CACHE_PATH)$(PATHSEP)bucket.hpp \
	$(CACHE_PATH)$(PATHSEP)cacheb.hpp \
	$(CACHE_PATH)$(PATHSEP)cactype.hpp \
	$(EHANDLER_PATH)$(PATHSEP)ehandler.hpp \
	$(VBDFILE_PATH)$(PATHSEP)vbdfile.hpp \
	$(BTREE_PATH)$(PATHSEP)mnode.hpp \
	$(REFCOUNT_PATH)$(PATHSEP)refcount.hpp \
	$(DTYPES_PATH)$(PATHSEP)uint32.hpp 

CACHE_DEP = $(CACHE_PATH)$(PATHSEP)bucketb.hpp \
	$(CACHE_PATH)$(PATHSEP)cacheb.hpp \
	$(CACHE_PATH)$(PATHSEP)cactype.hpp \
	$(EHANDLER_PATH)$(PATHSEP)ehandler.hpp \
	$(VBDFILE_PATH)$(PATHSEP)vbdfile.hpp \
	$(BTREE_PATH)$(PATHSEP)mnode.hpp \
	$(REFCOUNT_PATH)$(PATHSEP)refcount.hpp \
	$(DTYPES_PATH)$(PATHSEP)uint32.hpp 

CACHEB_DEP = $(CACHE_PATH)$(PATHSEP)bucketb.hpp \
	$(CACHE_PATH)$(PATHSEP)cacheb.hpp \
	$(EHANDLER_PATH)$(PATHSEP)ehandler.hpp \
	$(VBDFILE_PATH)$(PATHSEP)vbdfile.hpp \
	$(REFCOUNT_PATH)$(PATHSEP)refcount.hpp \
	$(DTYPES_PATH)$(PATHSEP)int32.hpp \
	$(DTYPES_PATH)$(PATHSEP)dtypes.hpp \
	$(DTYPES_PATH)$(PATHSEP)uint32.hpp 

CHPTRB_DEP = $(CACHE_PATH)$(PATHSEP)bucket.hpp \
	$(CACHE_PATH)$(PATHSEP)bucketb.hpp \
	$(CACHE_PATH)$(PATHSEP)cache.hpp \
	$(CACHE_PATH)$(PATHSEP)cacheb.hpp \
	$(CACHE_PATH)$(PATHSEP)chptrb.hpp \
	$(CACHE_PATH)$(PATHSEP)cactype.hpp\
	$(EHANDLER_PATH)$(PATHSEP)ehandler.hpp \
	$(VBDFILE_PATH)$(PATHSEP)vbdfile.hpp \
	$(REFCOUNT_PATH)$(PATHSEP)refcount.hpp \
	$(DTYPES_PATH)$(PATHSEP)int32.hpp \
	$(DTYPES_PATH)$(PATHSEP)dtypes.hpp \
	$(DTYPES_PATH)$(PATHSEP)uint32.hpp 

MNODE_DEP = $(BTREE_PATH)$(PATHSEP)mnode.hpp \
	$(EHANDLER_PATH)$(PATHSEP)ehandler.hpp \
	$(DTYPES_PATH)$(PATHSEP)int32.hpp \
	$(DTYPES_PATH)$(PATHSEP)dtypes.hpp \
	$(BTREE_PATH)$(PATHSEP)entrykey.hpp 

ENTRYKEY_DEP = $(BTREE_PATH)$(PATHSEP)entrykey.hpp \
	$(EHANDLER_PATH)$(PATHSEP)ehandler.hpp \
	$(DTYPES_PATH)$(PATHSEP)int32.hpp \
	$(DTYPES_PATH)$(PATHSEP)dtypes.hpp 

BTREE_DEP = $(CACHE_PATH)$(PATHSEP)bucket.hpp \
	$(CACHE_PATH)$(PATHSEP)bucketb.hpp \
	$(CACHE_PATH)$(PATHSEP)cache.hpp \
	$(CACHE_PATH)$(PATHSEP)cacheb.hpp \
	$(CACHE_PATH)$(PATHSEP)chptrb.hpp \
	$(CACHE_PATH)$(PATHSEP)cactype.hpp\
	$(CACHE_PATH)$(PATHSEP)cacheptr.hpp \
	$(BTREE_PATH)$(PATHSEP)btree.hpp \
	$(EHANDLER_PATH)$(PATHSEP)ehandler.hpp \
	$(VBDFILE_PATH)$(PATHSEP)vbdfile.hpp \
	$(REFCOUNT_PATH)$(PATHSEP)refcount.hpp \
	$(PLACENEW_PATH)$(PATHSEP)placenew.hpp \
	$(BTREE_PATH)$(PATHSEP)mnode.hpp \
	$(DTYPES_PATH)$(PATHSEP)int32.hpp\
	$(DTYPES_PATH)$(PATHSEP)dtypes.hpp \
	$(BTREE_PATH)$(PATHSEP)entrykey.hpp \
	$(DTYPES_PATH)$(PATHSEP)uint32.hpp 

POD_DEP = $(POD_PATH)$(PATHSEP)pod.hpp \
	$(CACHE_PATH)$(PATHSEP)bucket.hpp \
	$(CACHE_PATH)$(PATHSEP)bucketb.hpp \
	$(CACHE_PATH)$(PATHSEP)cache.hpp \
	$(CACHE_PATH)$(PATHSEP)cacheb.hpp \
	$(CACHE_PATH)$(PATHSEP)chptrb.hpp \
	$(CACHE_PATH)$(PATHSEP)cactype.hpp \
	$(CACHE_PATH)$(PATHSEP)cacheptr.hpp \
	$(BTREE_PATH)$(PATHSEP)btree.hpp \
	$(EHANDLER_PATH)$(PATHSEP)ehandler.hpp \
	$(VBDFILE_PATH)$(PATHSEP)vbdfile.hpp \
	$(REFCOUNT_PATH)$(PATHSEP)refcount.hpp \
	$(PLACENEW_PATH)$(PATHSEP)placenew.hpp \
	$(BTREE_PATH)$(PATHSEP)mnode.hpp \
	$(DTYPES_PATH)$(PATHSEP)int32.hpp \
	$(DTYPES_PATH)$(PATHSEP)dtypes.hpp \
	$(BTREE_PATH)$(PATHSEP)entrykey.hpp \
	$(BTREE_PATH)$(PATHSEP)btree.hpp \
	$(DTYPES_PATH)$(PATHSEP)uint32.hpp 

PERSIST_DEP = $(POD_PATH)$(PATHSEP)pod.hpp \
	$(CACHE_PATH)$(PATHSEP)bucket.hpp \
	$(CACHE_PATH)$(PATHSEP)bucketb.hpp \
	$(CACHE_PATH)$(PATHSEP)cache.hpp \
	$(CACHE_PATH)$(PATHSEP)cacheb.hpp \
	$(CACHE_PATH)$(PATHSEP)chptrb.hpp \
	$(CACHE_PATH)$(PATHSEP)cactype.hpp \
	$(CACHE_PATH)$(PATHSEP)cacheptr.hpp \
	$(BTREE_PATH)$(PATHSEP)btree.hpp \
	$(EHANDLER_PATH)$(PATHSEP)ehandler.hpp \
	$(VBDFILE_PATH)$(PATHSEP)vbdfile.hpp \
	$(REFCOUNT_PATH)$(PATHSEP)refcount.hpp \
	$(PLACENEW_PATH)$(PATHSEP)placenew.hpp \
	$(BTREE_PATH)$(PATHSEP)mnode.hpp \
	$(DTYPES_PATH)$(PATHSEP)int32.hpp \
	$(DTYPES_PATH)$(PATHSEP)dtypes.hpp \
	$(BTREE_PATH)$(PATHSEP)entrykey.hpp \
	$(BTREE_PATH)$(PATHSEP)btree.hpp \
	$(PERSIST_PATH)$(PATHSEP)persist.hpp \
	$(DTYPES_PATH)$(PATHSEP)uint32.hpp 

EHANDLER_DEP = $(EHANDLER_PATH)$(PATHSEP)ehandler.hpp 

VBDFILE_DEP = $(EHANDLER_PATH)$(PATHSEP)ehandler.hpp \
	$(VBDFILE_PATH)$(PATHSEP)vbdfile.hpp \
	$(REFCOUNT_PATH)$(PATHSEP)refcount.hpp \
	$(DTYPES_PATH)$(PATHSEP)dtypes.hpp \
	$(DTYPES_PATH)$(PATHSEP)int32.hpp \
	$(DTYPES_PATH)$(PATHSEP)uint32.hpp \
	$(CRC32_PATH)$(PATHSEP)crc32.hpp 

INT32_DEP =  $(EHANDLER_PATH)$(PATHSEP)ehandler.hpp \
	$(DTYPES_PATH)$(PATHSEP)dtypes.hpp \
	$(DTYPES_PATH)$(PATHSEP)int32.hpp

VBDREF_DEP = $(VBDFILE_PATH)$(PATHSEP)vbdfile.hpp \
	$(VBDFILE_PATH)$(PATHSEP)vbdref.hpp \
	$(REFCOUNT_PATH)$(PATHSEP)refcount.hpp

USTRING_DEP = $(USTRING_PATH)$(PATHSEP)ustring.hpp


SLLISTB_DEP = $(SLLISTB_PATH)$(PATHSEP)sllistb.hpp

GROCERY_DEP = $(DTYPES_PATH)$(PATHSEP)dtypes.hpp \
	$(EHANDLER_PATH)$(PATHSEP)ehandler.hpp \
	$(GROCERY_PATH)$(PATHSEP)grocery.hpp \
	$(DTYPES_PATH)$(PATHSEP)float64.hpp \
	$(DTYPES_PATH)$(PATHSEP)int32.hpp \
	$(PERSIST_PATH)$(PATHSEP)persist.hpp \
	$(POD_PATH)$(PATHSEP)pod.hpp \
	$(VBDFILE_PATH)$(PATHSEP)vbdref.hpp \
	$(USTRING_PATH)$(PATHSEP)ustring.hpp \
	$(VBDFILE_PATH)$(PATHSEP)vbdfile.hpp \
	$(DTYPES_PATH)$(PATHSEP)uint32.hpp 

ASPRINT_DEP = $(ASPRINT_PATH)$(PATHSEP)asprint.hpp

FLOAT64_DEP =  $(EHANDLER_PATH)$(PATHSEP)ehandler.hpp \
	$(DTYPES_PATH)$(PATHSEP)dtypes.hpp \
	$(DTYPES_PATH)$(PATHSEP)float64.hpp

WINMAIN_DEP = $(DTYPES_PATH)$(PATHSEP)dtypes.hpp \
	$(EHANDLER_PATH)$(PATHSEP)ehandler.hpp \
	$(GROCERY_PATH)$(PATHSEP)grocery.hpp \
	$(DTYPES_PATH)$(PATHSEP)float64.hpp \
	$(DTYPES_PATH)$(PATHSEP)int32.hpp \
	$(PERSIST_PATH)$(PATHSEP)persist.hpp \
	$(POD_PATH)$(PATHSEP)pod.hpp \
	$(VBDFILE_PATH)$(PATHSEP)vbdref.hpp \
	$(SLLISTB_PATH)$(PATHSEP)sllist.hpp \
	$(SLLISTB_PATH)$(PATHSEP)sllistb.hpp \
	$(USTRING_PATH)$(PATHSEP)ustring.hpp \
	$(VBDFILE_PATH)$(PATHSEP)vbdfile.hpp \
	$(CHSLIST_PATH)$(PATHSEP)chslist.hpp \
	$(CONFIG_PATH)$(PATHSEP)config.hpp \
	$(TIMER_PATH)$(PATHSEP)timer.hpp \
	$(GROCERY_PATH)$(PATHSEP)version.hpp \
	$(CACHE_PATH)$(PATHSEP)bucket.hpp \
	$(CACHE_PATH)$(PATHSEP)bucketb.hpp \
	$(CACHE_PATH)$(PATHSEP)cache.hpp \
	$(CACHE_PATH)$(PATHSEP)cacheb.hpp \
	$(CACHE_PATH)$(PATHSEP)chptrb.hpp \
	$(CACHE_PATH)$(PATHSEP)cacheptr.hpp \
	$(CACHE_PATH)$(PATHSEP)cactype.hpp \
	$(BTREE_PATH)$(PATHSEP)btree.hpp \
	$(PLACENEW_PATH)$(PATHSEP)placenew.hpp \
	$(BTREE_PATH)$(PATHSEP)mnode.hpp \
	$(ASPRINT_PATH)$(PATHSEP)asprint.hpp \
	$(DLLISTB_PATH)$(PATHSEP)dllistb.hpp \
	$(DLLISTB_PATH)$(PATHSEP)dllist.hpp \
	$(BTREE_PATH)$(PATHSEP)btwalk.hpp \
	$(QUEUE_PATH)$(PATHSEP)queue.hpp \
	$(STACK_PATH)$(PATHSEP)stack.hpp \
	$(RBTREE_PATH)$(PATHSEP)bnode.hpp \
	$(RBTREE_PATH)$(PATHSEP)bnodeb.hpp \
	$(RBTREE_PATH)$(PATHSEP)bstreeb.hpp \
	$(RBTREE_PATH)$(PATHSEP)rbnode.hpp \
	$(RBTREE_PATH)$(PATHSEP)rbtree.hpp \
	$(RBTREE_PATH)$(PATHSEP)rbtreeb.hpp \
	$(RBTREE_PATH)$(PATHSEP)twalk.hpp \
	$(STRUTIL_PATH)$(PATHSEP)strutil.hpp \
	$(GROCERY_PATH)$(PATHSEP)dbconfig.hpp \
	$(GROCERY_PATH)$(PATHSEP)groc_sh.hpp  \
	$(DTYPES_PATH)$(PATHSEP)uint32.hpp \
	$(VBDFILE_PATH)$(PATHSEP)vbdstats.hpp \
	$(APP_PATH)$(PATHSEP)winmain.hpp

GROC_SH_DEP = $(GROCERY_PATH)$(PATHSEP)grocery.hpp \
	$(DTYPES_PATH)$(PATHSEP)dtypes.hpp \
	$(EHANDLER_PATH)$(PATHSEP)ehandler.hpp \
	$(DTYPES_PATH)$(PATHSEP)float64.hpp \
	$(DTYPES_PATH)$(PATHSEP)int32.hpp \
	$(PERSIST_PATH)$(PATHSEP)persist.hpp \
	$(POD_PATH)$(PATHSEP)pod.hpp \
	$(VBDFILE_PATH)$(PATHSEP)vbdref.hpp \
	$(VBDFILE_PATH)$(PATHSEP)vbdfile.hpp \
	$(SLLISTB_PATH)$(PATHSEP)sllist.hpp \
	$(SLLISTB_PATH)$(PATHSEP)sllistb.hpp \
	$(CACHE_PATH)$(PATHSEP)bucket.hpp \
	$(CACHE_PATH)$(PATHSEP)bucketb.hpp \
	$(CACHE_PATH)$(PATHSEP)cache.hpp \
	$(CACHE_PATH)$(PATHSEP)cacheb.hpp \
	$(CACHE_PATH)$(PATHSEP)chptrb.hpp \
	$(CACHE_PATH)$(PATHSEP)cacheptr.hpp \
	$(CACHE_PATH)$(PATHSEP)cactype.hpp \
	$(BTREE_PATH)$(PATHSEP)btree.hpp \
	$(PLACENEW_PATH)$(PATHSEP)placenew.hpp \
	$(BTREE_PATH)$(PATHSEP)mnode.hpp \
	$(DLLISTB_PATH)$(PATHSEP)dllistb.hpp \
	$(DLLISTB_PATH)$(PATHSEP)dllist.hpp \
	$(BTREE_PATH)$(PATHSEP)btwalk.hpp \
	$(QUEUE_PATH)$(PATHSEP)queue.hpp \
	$(STACK_PATH)$(PATHSEP)stack.hpp \
	$(RBTREE_PATH)$(PATHSEP)bnode.hpp \
	$(RBTREE_PATH)$(PATHSEP)bnodeb.hpp \
	$(RBTREE_PATH)$(PATHSEP)bstreeb.hpp \
	$(RBTREE_PATH)$(PATHSEP)rbnode.hpp \
	$(RBTREE_PATH)$(PATHSEP)rbtree.hpp \
	$(RBTREE_PATH)$(PATHSEP)rbtreeb.hpp \
	$(RBTREE_PATH)$(PATHSEP)twalk.hpp \
	$(USTRING_PATH)$(PATHSEP)ustring.hpp \
	$(DTYPES_PATH)$(PATHSEP)uint32.hpp 

CONFIG_DEP = $(CHSLIST_PATH)$(PATHSEP)chslist.hpp \
	$(CONFIG_PATH)$(PATHSEP)config.hpp \
	$(SLLISTB_PATH)$(PATHSEP)sllistb.hpp

STRUTIL_DEP = $(STRUTIL_PATH)$(PATHSEP)strutil.hpp 

DLLISTB_DEP = $(DLLISTB_PATH)$(PATHSEP)dllistb.hpp

CHSLIST_DEP = $(CHSLIST_PATH)$(PATHSEP)chslist.hpp \
	$(SLLISTB_PATH)$(PATHSEP)sllistb.hpp

BTWALK_DEP = $(CACHE_PATH)$(PATHSEP)bucket.hpp \
	$(CACHE_PATH)$(PATHSEP)bucketb.hpp \
	$(CACHE_PATH)$(PATHSEP)cache.hpp \
	$(CACHE_PATH)$(PATHSEP)cacheb.hpp \
	$(CACHE_PATH)$(PATHSEP)chptrb.hpp \
	$(CACHE_PATH)$(PATHSEP)cactype.hpp\
	$(CACHE_PATH)$(PATHSEP)cacheptr.hpp \
	$(BTREE_PATH)$(PATHSEP)btree.hpp \
	$(EHANDLER_PATH)$(PATHSEP)ehandler.hpp \
	$(VBDFILE_PATH)$(PATHSEP)vbdfile.hpp \
	$(REFCOUNT_PATH)$(PATHSEP)refcount.hpp \
	$(PLACENEW_PATH)$(PATHSEP)placenew.hpp \
	$(BTREE_PATH)$(PATHSEP)mnode.hpp \
	$(DTYPES_PATH)$(PATHSEP)int32.hpp\
	$(DTYPES_PATH)$(PATHSEP)dtypes.hpp \
	$(BTREE_PATH)$(PATHSEP)entrykey.hpp \
	$(BTREE_PATH)$(PATHSEP)btwalk.hpp \
	$(USTRING_PATH)$(PATHSEP)ustring.hpp \
	$(STRUTIL_PATH)$(PATHSEP)strutil.hpp \
	$(DTYPES_PATH)$(PATHSEP)uint32.hpp 	

BNODEB_DEP = $(RBTREE_PATH)$(PATHSEP)bnodeb.hpp \
	$(QUEUE_PATH)$(PATHSEP)queue.hpp \
	$(SLLISTB_PATH)$(PATHSEP)sllist.hpp \
	$(SLLISTB_PATH)$(PATHSEP)sllistb.hpp \
	$(STACK_PATH)$(PATHSEP)stack.hpp

BSTREEB_DEP = $(RBTREE_PATH)$(PATHSEP)bnode.hpp \
	$(RBTREE_PATH)$(PATHSEP)bnodeb.hpp \
	$(RBTREE_PATH)$(PATHSEP)bstreeb.hpp 

RBTREEB_DEP = $(RBTREE_PATH)$(PATHSEP)bnode.hpp \
	$(RBTREE_PATH)$(PATHSEP)bnodeb.hpp \
	$(RBTREE_PATH)$(PATHSEP)bstreeb.hpp \
	$(QUEUE_PATH)$(PATHSEP)queue.hpp \
	$(RBTREE_PATH)$(PATHSEP)rbnode.hpp \
	$(RBTREE_PATH)$(PATHSEP)rbtree.hpp \
	$(RBTREE_PATH)$(PATHSEP)rbtreeb.hpp \
	$(SLLISTB_PATH)$(PATHSEP)sllist.hpp \
	$(SLLISTB_PATH)$(PATHSEP)sllistb.hpp \
	$(STACK_PATH)$(PATHSEP)stack.hpp \
	$(RBTREE_PATH)$(PATHSEP)twalk.hpp

TWALK_DEP = $(RBTREE_PATH)$(PATHSEP)bnode.hpp \
	$(RBTREE_PATH)$(PATHSEP)bnodeb.hpp \
	$(QUEUE_PATH)$(PATHSEP)queue.hpp \
	$(RBTREE_PATH)$(PATHSEP)rbnode.hpp \
	$(SLLISTB_PATH)$(PATHSEP)sllist.hpp \
	$(SLLISTB_PATH)$(PATHSEP)sllistb.hpp \
	$(STACK_PATH)$(PATHSEP)stack.hpp \
	$(RBTREE_PATH)$(PATHSEP)twalk.hpp

PSCRIPT_DEP = $(PSCRIPT_PATH)$(PATHSEP)pscript.hpp
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT).exe

vbdstats.obj:	$(VBDFILE_PATH)$(PATHSEP)vbdstats.cpp $(VBDSTATS_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBDFILE_PATH)$(PATHSEP)vbdstats.cpp

uint32.obj:	$(DTYPES_PATH)$(PATHSEP)uint32.cpp $(UINT31_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(DTYPES_PATH)$(PATHSEP)uint32.cpp

crc32.obj:	$(CRC32_PATH)$(PATHSEP)crc32.cpp $(CRC32_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(CRC32_PATH)$(PATHSEP)crc32.cpp

bnodeb.obj:	$(RBTREE_PATH)$(PATHSEP)bnodeb.cpp $(BNODEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(RBTREE_PATH)$(PATHSEP)bnodeb.cpp

bstreeb.obj:	$(RBTREE_PATH)$(PATHSEP)bstreeb.cpp $(BSTREEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(RBTREE_PATH)$(PATHSEP)bstreeb.cpp

rbtreeb.obj:	$(RBTREE_PATH)$(PATHSEP)rbtreeb.cpp $(RBTREEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(RBTREE_PATH)$(PATHSEP)rbtreeb.cpp

twalk.obj:	$(RBTREE_PATH)$(PATHSEP)twalk.cpp $(TWALK_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(RBTREE_PATH)$(PATHSEP)twalk.cpp

bucket.obj:	$(CACHE_PATH)$(PATHSEP)bucket.cpp $(BUCKET_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(CACHE_PATH)$(PATHSEP)bucket.cpp

cache.obj:	$(CACHE_PATH)$(PATHSEP)cache.cpp $(CACHE_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(CACHE_PATH)$(PATHSEP)cache.cpp

cacheb.obj:	$(CACHE_PATH)$(PATHSEP)cacheb.cpp $(CACHEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(CACHE_PATH)$(PATHSEP)cacheb.cpp

chptrb.obj:	$(CACHE_PATH)$(PATHSEP)chptrb.cpp $(CHPTRB_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(CACHE_PATH)$(PATHSEP)chptrb.cpp

mnode.obj:	$(BTREE_PATH)$(PATHSEP)mnode.cpp $(MNODE_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(BTREE_PATH)$(PATHSEP)mnode.cpp

entrykey.obj:	$(BTREE_PATH)$(PATHSEP)entrykey.cpp $(ENTRYKEY_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(BTREE_PATH)$(PATHSEP)entrykey.cpp

btree.obj:	$(BTREE_PATH)$(PATHSEP)btree.cpp $(BTREE_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(BTREE_PATH)$(PATHSEP)btree.cpp

ehandler.obj:	$(EHANDLER_PATH)$(PATHSEP)ehandler.cpp $(EHANDLER_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(EHANDLER_PATH)$(PATHSEP)ehandler.cpp

vbdfile.obj:	$(VBDFILE_PATH)$(PATHSEP)vbdfile.cpp $(VBDFILE_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBDFILE_PATH)$(PATHSEP)vbdfile.cpp

winmain.obj:	$(APP_PATH)$(PATHSEP)winmain.cpp $(WINMAIN_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(APP_PATH)$(PATHSEP)winmain.cpp

ustring.obj:	$(USTRING_PATH)$(PATHSEP)ustring.cpp $(USTRING_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(USTRING_PATH)$(PATHSEP)ustring.cpp

int32.obj:	$(DTYPES_PATH)$(PATHSEP)int32.cpp $(INT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(DTYPES_PATH)$(PATHSEP)int32.cpp

sllistb.obj:	$(SLLISTB_PATH)$(PATHSEP)sllistb.cpp $(SLLISTB_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(SLLISTB_PATH)$(PATHSEP)sllistb.cpp

dllistb.obj:	$(DLLISTB_PATH)$(PATHSEP)dllistb.cpp $(DLLISTB_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(DLLISTB_PATH)$(PATHSEP)dllistb.cpp

vbdref.obj:	$(VBDFILE_PATH)$(PATHSEP)vbdref.cpp $(VBDREF_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBDFILE_PATH)$(PATHSEP)vbdref.cpp

pod.obj:	$(POD_PATH)$(PATHSEP)pod.cpp $(POD_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(POD_PATH)$(PATHSEP)pod.cpp

persist.obj:	$(PERSIST_PATH)$(PATHSEP)persist.cpp $(PERSIST_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(PERSIST_PATH)$(PATHSEP)persist.cpp

grocery.obj:	$(GROCERY_PATH)$(PATHSEP)grocery.cpp $(GROCERY_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GROCERY_PATH)$(PATHSEP)grocery.cpp

chslist.obj:	$(CHSLIST_PATH)$(PATHSEP)chslist.cpp $(CHSLIST_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(CHSLIST_PATH)$(PATHSEP)chslist.cpp

config.obj:	$(CONFIG_PATH)$(PATHSEP)config.cpp $(CONFIG_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(CONFIG_PATH)$(PATHSEP)config.cpp

strutil.obj:	$(STRUTIL_PATH)$(PATHSEP)strutil.cpp $(STRUTIL_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(STRUTIL_PATH)$(PATHSEP)strutil.cpp

asprint.obj:	$(ASPRINT_PATH)$(PATHSEP)asprint.cpp $(ASPRINT_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(ASPRINT_PATH)$(PATHSEP)asprint.cpp

groc_sh.obj:	$(GROCERY_PATH)$(PATHSEP)groc_sh.cpp $(GROC_SH_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GROCERY_PATH)$(PATHSEP)groc_sh.cpp

btwalk.obj:	$(BTREE_PATH)$(PATHSEP)btwalk.cpp $(BTWALK_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(BTREE_PATH)$(PATHSEP)btwalk.cpp

float64.obj:	$(DTYPES_PATH)$(PATHSEP)float64.cpp $(FLOAT64_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(DTYPES_PATH)$(PATHSEP)float64.cpp

pscript.obj:	$(PSCRIPT_PATH)$(PATHSEP)pscript.cpp $(PSCRIPT_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(PSCRIPT_PATH)$(PATHSEP)pscript.cpp

winmain.res:	$(APP_PATH)$(PATHSEP)winmain.rc $(WXDIR)\include\msw\wx.rc
	$(RC) -r /i$(WXDIR)\include\msw /i$(WXDIR)\contrib\fafa -fo$@ \
	$(APP_PATH)$(PATHSEP)winmain.rc

# Make the executable
OBJECTS = winmain.obj int32.obj vbdfile.obj asprint.obj persist.obj \
	ustring.obj pod.obj grocery.obj sllistb.obj chslist.obj \
	config.obj vbdref.obj cacheb.obj chptrb.obj btree.obj \
	mnode.obj bucket.obj cache.obj entrykey.obj dllistb.obj \
	pscript.obj strutil.obj btwalk.obj bnodeb.obj bstreeb.obj \
	rbtreeb.obj twalk.obj groc_sh.obj float64.obj ehandler.obj \
	uint32.obj crc32.obj vbdstats.obj

RCS = winmain.res

$(PROJECT).exe:	$(DUMMYOBJ) $(OBJECTS) $(RCS) $(WXLIB)
	$(LINKER) $(LINK_FLAGS) $(DUMMYOBJ) $(OBJECTS) $(RCS) \
	$(LINK_LIBS) /OUT:$@ 
# ===============================================================

# Install the binaries to the bin directory
# ===============================================================
install:
	@echo Installing $(PROJECT) binaries to the bin directory...
	@if exist $(PROJECT).exe copy $(PROJECT).exe $(INSTALL_DIR)
# ===============================================================

# Remove OBJS, debug files, and executable after running nmake 
# ===============================================================
clean:
	@echo Removing all .SBR files from working directory...
	if exist *.sbr del *.sbr  

	@echo Removing all .VCW files from working directory...
	if exist *.vcw del *.vcw 

	@echo Removing all .PDB files from working directory...
	if exist *.pdb del *.pdb 

	@echo Removing all .WSP files from working directory...
	if exist *.wsp del *.wsp 

	@echo Removing all .BSC files from working directory...
	if exist *.bsc del *.bsc 

	@echo Removing all .SBT files from working directory...
	if exist *.sbt del *.sbt 

	@echo Removing all .ILK files from working directory...
	if exist *.ilk del *.ilk 

	@echo Removing all .IDB files from working directory...
	if exist *.idb del *.idb 

	@echo Removing all .MDP files from working directory...
	if exist *.mdp del *.mdp 

	@echo Removing all .PCH files from working directory...
	if exist *.pch del *.pch 

	@echo Removing all .NCB files from working directory...
	if exist *.ncb del *.ncb 

	@echo Removing all .RES files from working directory...
	if exist *.res del *.res 

	@echo Removing all .OBJ files from working directory...
	if exist *.obj del *.obj 

	@echo Removing the EXECUTABLE file from working directory
	if exist $(PROJECT).exe del $(PROJECT).exe 
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################


